## mingw-w64-jack2-1.9.22-1.src.tar.zst

=== common/wscript ===
#! /usr/bin/python3
# encoding: utf-8

import os


def configure(conf):
    conf.env['BUILD_NETLIB'] = conf.env['SAMPLERATE']
    conf.env['BUILD_ADAPTER'] = conf.env['SAMPLERATE']

    if conf.env['IS_WINDOWS']:
        try:
            conf.check(header_name='regex.h', lib='regex', uselib_store='REGEX', define_name='HAVE_REGEX_H')
        except Exception:
            conf.check(header_name='tre/regex.h', lib='tre', uselib_store='REGEX', define_name='HAVE_TRE_REGEX_H')
        conf.check(header_name='winsock2.h', lib='ws2_32', uselib_store='WS2_32', define_name='HAVE_WINSOCK2_H')
        conf.check(
            header_name=['windows.h', 'mmsystem.h'], lib='winmm', uselib_store='WINMM', define_name='HAVE_MMSYSTEM_H'
        )
        conf.check(header_name=['windows.h', 'psapi.h'], lib='psapi', uselib_store='PSAPI', define_name='HAVE_PSAPI_H')


def create_jack_process_obj(bld, target, sources, uselib=None, framework=None):
    process = bld(features=['cxx', 'cxxshlib'])
    if not bld.env['IS_WINDOWS']:
        process.env['cxxshlib_PATTERN'] = '%s.so'
    process.defines = ['HAVE_CONFIG_H', 'SERVER_SIDE']
    if bld.env['IS_MACOSX']:
        if framework:
            process.framework = framework
        env_includes = ['../macosx', '../posix', '../macosx/coreaudio']
    if bld.env['IS_LINUX']:
        env_includes = ['../linux', '../posix', '../linux/alsa']
    if bld.env['IS_FREEBSD']:
        env_includes = ['../freebsd', '../posix', '../solaris/oss']
    if bld.env['IS_SUN']:
        env_includes = ['../solaris', '../posix', '../solaris/oss']
    if bld.env['IS_WINDOWS']:
        env_includes = ['../windows', '../windows/portaudio']
    process.includes = ['.'] + env_includes + ['jack', '..']
    process.name = target
    process.target = target
    process.source = sources
    if bld.env['IS_LINUX'] or bld.env['IS_MACOSX'] or bld.env['IS_FREEBSD']:
        process.env.append_value('CPPFLAGS', '-fvisibility=hidden')
    process.install_path = '${ADDON_DIR}/'
    process.use = [uselib.name]
    return process


def build(bld):
    common_libsources = [
        'JackActivationCount.cpp',
        'JackAPI.cpp',
        'JackClient.cpp',
        'JackConnectionManager.cpp',
        'ringbuffer.c',
        'JackError.cpp',
        'JackException.cpp',
        'JackFrameTimer.cpp',
        'JackGraphManager.cpp',
        'JackPort.cpp',
        'JackPortType.cpp',
        'JackAudioPort.cpp',
        'JackMidiPort.cpp',
        'JackMidiAPI.cpp',
        'JackEngineControl.cpp',
        'JackShmMem.cpp',
        'JackGenericClientChannel.cpp',
        'shm.c',
        'JackGlobals.cpp',
        'JackTransportEngine.cpp',
        'JackTools.cpp',
        'JackMessageBuffer.cpp',
        'JackEngineProfiling.cpp',
        ]

    includes = ['.', './jack']
    if not bld.variant:
        includes.append('..')
    else:
        includes.append('../..')
    uselib = ['CELT', 'OPUS', 'DB', 'PTHREAD', 'SAMPLERATE']

    if bld.env['IS_LINUX']:
        common_libsources += [
            'JackDebugClient.cpp',
            'timestamps.c',
            'promiscuous.c',
            '../posix/JackPosixThread.cpp',
            '../posix/JackPosixProcessSync.cpp',
            '../posix/JackPosixMutex.cpp',
            '../posix/JackSocket.cpp',
            '../linux/JackLinuxFutex.cpp',
            '../linux/JackLinuxTime.c',
            ]
        includes = ['../linux', '../posix'] + includes
        uselib.append('RT')
        uselib.append('DL')

    if bld.env['IS_FREEBSD']:
        common_libsources += [
            'JackDebugClient.cpp',
            'timestamps.c',
            'promiscuous.c',
            '../posix/JackPosixThread.cpp',
            '../posix/JackPosixProcessSync.cpp',
            '../posix/JackPosixMutex.cpp',
            '../posix/JackPosixSemaphore.cpp',
            '../posix/JackSocket.cpp',
            '../posix/JackPosixTime.c',
            ]
        includes = ['../freebsd', '../posix'] + includes

    if bld.env['IS_SUN']:
        common_libsources += [
            'JackDebugClient.cpp',
            'timestamps.c',
            'promiscuous.c',
            '../posix/JackPosixThread.cpp',
            '../posix/JackFifo.cpp',
            '../posix/JackPosixProcessSync.cpp',
            '../posix/JackPosixMutex.cpp',
            '../posix/JackSocket.cpp',
            '../solaris/JackSolarisTime.c',
        ]
        includes = ['../solaris', '../posix'] + includes
        uselib.append('RT')

    if bld.env['IS_MACOSX']:
        common_libsources += [
            'JackDebugClient.cpp',
            'timestamps.c',
            'promiscuous.c',
            '../posix/JackPosixProcessSync.cpp',
            '../posix/JackPosixThread.cpp',
            '../posix/JackPosixMutex.cpp',
            '../macosx/JackMachThread.mm',
            '../macosx/JackMachSemaphore.mm',
            '../macosx/JackMachSemaphoreServer.mm',
            '../posix/JackSocket.cpp',
            '../macosx/JackMachTime.c',
            ]
        includes = ['../macosx', '../macosx/RPC', '../posix'] + includes

    if bld.env['IS_WINDOWS']:
        common_libsources += [
            '../windows/JackWinMutex.cpp',
            '../windows/JackWinProcessSync.cpp',
            '../windows/JackWinSemaphore.cpp',
            '../windows/JackWinThread.cpp',
            '../windows/JackWinTime.c',
            ]
        includes = ['../windows'] + includes
        libsuffix = "64" if (bld.env['DEST_CPU'] == "x86_64" and not bld.variant) else ""
        buildbindir = os.path.join('..', bld.path.get_bld().srcpath().rstrip(bld.path.srcpath()))
        staticbuild = bool('BUILD_STATIC' in bld.env and bld.env['BUILD_STATIC'])
        uselib.append('REGEX')
        uselib.append('WS2_32')
        uselib.append('PSAPI')
        uselib.append('WINMM')

    else:
        libsuffix = ""

    clientlib = bld(features=['c', 'cxx', 'cxxshlib', 'cshlib'])
    if bld.env['IS_MACOSX']:
        clientlib.framework = ['CoreAudio', 'Accelerate']
    clientlib.defines = 'HAVE_CONFIG_H'
    clientlib.includes = includes
    clientlib.name = 'clientlib'
    clientlib.target = 'jack'+libsuffix
    clientlib.install_path = '${LIBDIR}'
    clientlib.use = uselib
    if bld.env['IS_WINDOWS']:
        clientlib.env['cxxshlib_PATTERN'] = 'lib%s.dll'
        clientlib.env['cxxstlib_PATTERN'] = 'lib%s.a'
        clientlib.env['implib_PATTERN'] = 'lib%s.dll.a'
        if staticbuild:
            clientlib.env['SHLIB_MARKER'] = ''
        clientlib.env.append_value('LINKFLAGS', ['-static-libstdc++', '--disable-auto-import'])
        clientlib.env.append_value('LINKFLAGS', ['-Wl,--output-def,lib%s.def' % clientlib.target])
        bld.install_files(clientlib.install_path, [os.path.join(buildbindir, 'lib%s.def' % clientlib.target)])

    if bld.env['AUTOSTART_METHOD'] == 'dbus':
        clientlib.use.append('DBUS-1')
    clientlib.source = [] + common_libsources
    clientlib.source += [
        'JackLibClient.cpp',
        'JackLibAPI.cpp',
        'JackMetadata.cpp',
        ]

    if bld.env['IS_LINUX']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_FREEBSD']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_SUN']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_MACOSX']:
        clientlib.source += [
            '../posix/JackSocketClientChannel.cpp',
            '../posix/JackPosixServerLaunch.cpp',
            ]

    if bld.env['IS_WINDOWS']:
        clientlib.source += [
            '../windows/JackWinNamedPipe.cpp',
            '../windows/JackWinNamedPipeClientChannel.cpp',
            '../windows/JackWinServerLaunch.cpp',
            '../windows/JackMMCSS.cpp',
            ]

    if bld.env['IS_MACOSX']:
        clientlib.cnum = bld.env['JACK_API_VERSION']
        clientlib.vnum = bld.env['JACK_VERSION']
    elif not bld.env['IS_WINDOWS']:
        clientlib.vnum = bld.env['JACK_API_VERSION']

    if bld.env['IS_LINUX']:
        clientlib.env.append_value('CPPFLAGS', '-fvisibility=hidden')

    if bld.env['IS_FREEBSD']:
        clientlib.env.append_value('CPPFLAGS', '-fvisibility=hidden')

    if bld.env['IS_MACOSX']:
        clientlib.env.append_value('CPPFLAGS', '-fvisibility=hidden')
        clientlib.env.append_value('LINKFLAGS', '-single_module')

    if bld.env['IS_SUN']:
        clientlib.env.append_value('LINKFLAGS', '-lnsl -lsocket')

    if bld.variant:
        # if there is variant defined, we expect it to be the 32bit client lib one
        # we don't want to build other stuff in this variant
        return

    serverlib = bld(features=['c', 'cxx', 'cxxshlib', 'cshlib'])
    if bld.env['IS_MACOSX']:
        serverlib.framework = ['CoreAudio', 'CoreFoundation', 'Accelerate']
    serverlib.defines = ['HAVE_CONFIG_H', 'SERVER_SIDE']
    serverlib.includes = includes
    serverlib.name = 'serverlib'
    serverlib.target = 'jackserver'+libsuffix
    serverlib.install_path = '${LIBDIR}'
    serverlib.use = uselib
    if bld.env['IS_WINDOWS']:
        serverlib.env['cxxshlib_PATTERN'] = 'lib%s.dll'
        serverlib.env['cxxstlib_PATTERN'] = 'lib%s.a'
        serverlib.env['implib_PATTERN'] = 'lib%s.dll.a'
        if staticbuild:
            serverlib.env['SHLIB_MARKER'] = ''
        serverlib.env.append_value('LINKFLAGS', ['-static-libstdc++', '--disable-auto-import'])
        serverlib.env.append_value('LINKFLAGS', ['-Wl,--output-def,lib%s.def' % serverlib.target])
        bld.install_files(serverlib.install_path, [os.path.join(buildbindir, 'lib%s.def' % serverlib.target)])
    serverlib.source = [] + common_libsources
    serverlib.source += [
        'JackAudioDriver.cpp',
        'JackTimedDriver.cpp',
        'JackMidiDriver.cpp',
        'JackDriver.cpp',
        'JackEngine.cpp',
        'JackExternalClient.cpp',
        'JackFreewheelDriver.cpp',
        'JackInternalClient.cpp',
        'JackInternalSessionLoader.cpp',
        'JackServer.cpp',
        'JackThreadedDriver.cpp',
        'JackRestartThreadedDriver.cpp',
        'JackWaitThreadedDriver.cpp',
        'JackWaitCallbackDriver.cpp',
        'JackServerAPI.cpp',
        'JackDriverLoader.cpp',
        'JackServerGlobals.cpp',
        'JackControlAPI.cpp',
        'JackNetTool.cpp',
        'JackNetInterface.cpp',
        'JackArgParser.cpp',
        'JackRequestDecoder.cpp',
        'JackMidiAsyncQueue.cpp',
        'JackMidiAsyncWaitQueue.cpp',
        'JackMidiBufferReadQueue.cpp',
        'JackMidiBufferWriteQueue.cpp',
        'JackMidiRawInputWriteQueue.cpp',
        'JackMidiRawOutputWriteQueue.cpp',
        'JackMidiReadQueue.cpp',
        'JackMidiReceiveQueue.cpp',
        'JackMidiSendQueue.cpp',
        'JackMidiUtil.cpp',
        'JackMidiWriteQueue.cpp',
        'JackMetadata.cpp',
        ]

    if bld.env['IS_LINUX']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    if bld.env['IS_FREEBSD']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    if bld.env['IS_SUN']:
        serverlib.source += [
            '../posix/JackSocketServerChannel.cpp',
            '../posix/JackSocketNotifyChannel.cpp',
            '../posix/JackSocketServerNotifyChannel.cpp',
            '../posix/JackNetUnixSocket.cpp',
            ]

    if bld.env['IS_MACOSX']:
        serverlib.source += [

=== PKGBUILD ===
# Maintainer: Biswapriyo Nath <nathbappai@gmail.com>

_realname=jack2
pkgbase="mingw-w64-${_realname}"
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
pkgver=1.9.22
pkgrel=1
pkgdesc='The JACK low-latency audio server (mingw-w64)'
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64')
url='https://jackaudio.org/'
license=('GPL2')
depends=("${MINGW_PACKAGE_PREFIX}-db"
         "${MINGW_PACKAGE_PREFIX}-libsystre"
         "${MINGW_PACKAGE_PREFIX}-opus"
         "${MINGW_PACKAGE_PREFIX}-portaudio"
         "${MINGW_PACKAGE_PREFIX}-readline"
         "${MINGW_PACKAGE_PREFIX}-libsamplerate"
         "${MINGW_PACKAGE_PREFIX}-libsndfile")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "python")
source=("${_realname}-${pkgver}.tar.gz::https://github.com/jackaudio/jack2/archive/v${pkgver}.tar.gz"
        0001-wscript-remove-hardcoded-includedir.patch
        0003-relocate-plugins-libdir.patch
        0004-relocate-jackd-path.patch)
sha256sums=('1e42b9fc4ad7db7befd414d45ab2f8a159c0b30fcd6eee452be662298766a849'
            '5a343bfee863dd648e40161f59f197823092e215dd1daa04511ac4dbfb7bcf63'
            '797adc210372c18a49f3c02a91a27d615c843b1eacca29c738ccac2c8664dfe3'
            'a81826c43991b5add021b259abbf86f623808b7e1ed1c5cc6d8b6cb06b7ad1d5')

prepare() {
  cd "${srcdir}/${_realname}-${pkgver}"
  patch -p1 -i "${srcdir}/0001-wscript-remove-hardcoded-includedir.patch"

  # TODO: If posible replace these with pathtools
  patch -p1 -i "${srcdir}/0003-relocate-plugins-libdir.patch"
  patch -p1 -i "${srcdir}/0004-relocate-jackd-path.patch"
}

build() {
  cd "${srcdir}/${_realname}-${pkgver}"

  export LINKFLAGS="${LDFLAGS}"

  export WAF_NO_PREFORK=1

  /usr/bin/python ./waf configure \
    --prefix=${MINGW_PREFIX} \
    --check-c-compiler=${CC} \
    --check-cxx-compiler=${CXX} \
    --platform=win32 \
    --out="${srcdir}/build-${MSYSTEM}"

  /usr/bin/python ./waf build
}

package() {
  cd "${srcdir}/${_realname}-${pkgver}"
  /usr/bin/python ./waf install --destdir="${pkgdir}"

  # Workaround: Move jack DLLs to bindir but not the plugins
  mv -v "${pkgdir}${MINGW_PREFIX}"/lib/*.dll "${pkgdir}${MINGW_PREFIX}/bin/"

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/COPYING" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/COPYING"
}
